import { AfterViewInit, Component, Inject } from '@angular/core';

import { AppConfig, APP_CONFIG, FaviconService, PortalService } from '@cima/commons';

import {LangChangeEvent, TranslateService} from "@ngx-translate/core";


@Component({
  selector: '<%= dasherize(name) %>-app-container',
  templateUrl: './<%= dasherize(name) %>-app-container.component.html',
  styleUrls: ['./<%= dasherize(name) %>-app-container.component.scss'],
})
export class <%= classify(name) %>AppContainerComponent  implements AfterViewInit{
  constructor(
    @Inject(APP_CONFIG) private config: AppConfig,
    private faviconService: FaviconService,
    private portalService: PortalService,
    public translate: TranslateService,
  ) {

    let portal_current_language: string = this.translate.currentLang;
    if(!portal_current_language) portal_current_language = this.translate.defaultLang;
    this.portalService.getPortalLabels('mydewetra', '<%= dasherize(name) %>', portal_current_language);

    this.translate.onLangChange.subscribe((event: LangChangeEvent) => {
      this.portalService.getPortalLabels('mydewetra', '<%= dasherize(name) %>', event.lang);
    });

  }

  ngAfterViewInit() {
    this.faviconService.setAppFavicon(this.config.name);
    this.portalService.setTitle(this.config.description);
  }
}
